from sc2.client import *
from sc2.constants import *
import random

# from writedata import WriteData

class WarManager():
    def __init__(self, bot=None):
        self.bot = bot
        self.war_status = "Peace"
        self.prior_war_status = "Peace"
        self.enemy_units = None
        self.enemy_attackers = None
        self.enemy_attacker_count = None

    async def Run(self):
        await self.worker_rush()
        if self.war_status == "Defend":
            await self.defend_hq()
        elif (self.war_status == "Peace") and (self.prior_war_status == "Defend"):
            await self.back_to_work()

    async def worker_rush(self):
        hqlist = self.bot.units(self.bot.townhall)
        hqpositions = []
        for n in hqlist:
            hqpositions.append(n.position)

        enemy_units = self.bot.known_enemy_units.not_structure

        self.enemy_attackers = []
        self.enemy_attacker_count = 0
        for e in enemy_units:
            for n in hqpositions:
                distance2hq = e.position.distance_to(n)
                if distance2hq <= 40:
                    self.enemy_attackers.append(e)
                    self.enemy_attacker_count +=1

#        if (self.bot.time % 2) == 0:
#            print("enemies: " + str(self.enemy_attacker_count) + " ", end='')

        self.prior_war_status = self.war_status

        if self.enemy_attacker_count > 4:
            self.war_status = "Defend"
        elif self.enemy_attacker_count <= 1:
            self.war_status = "Peace"

    async def defend_hq(self):
        defenders = self.bot.units.not_structure.ready.filter(lambda w: w.type_id not in [UnitTypeId.LARVA]
            and w.type_id not in [UnitTypeId.EGG])
        d_max = min(len(defenders), self.enemy_attacker_count + 2)

#        print(" defenders: " + str(d_max))
#        for d in range (0, d_max):
        for d in defenders:
#            target = random.choice(self.bot.known_enemy_units).position
            target = random.choice(self.enemy_attackers).position
            await self.bot.do(d.attack(target))

    async def back_to_work(self):
        for drone in self.bot.workers:
            m = self.bot.state.mineral_field.closer_than(30, drone.position)
            await self.bot.do(drone.gather(m.random, queue=True))
