# Krillin
import json, sys
# Krillin

import sc2
from sc2.client import *
from techtree import *
from resources import *
from gamemanager import *
# from unitmanager import *
from Krillin.warmanager import *
# from protoss import *
# from terran import *
#from writedata import *

class Krillin(sc2.BotAI):
    # Krillin
    with open("botinfo.json") as f:
        NAME = json.load(f)["name"]
    # Krillin

    def __init__(self):
        super().__init__()
        self.techtree = TechTree(self)
        self.resources = Resources(self)
        self.gamemanager = GameManager(self)
        # self.unitmanager = UnitManager(self)
        self.warmanager = WarManager(self)
        # self.protossmanager = ProtossManager(self)
        # self.terranmanager = TerranManager(self)
        self.iteration = 0
		# self.last_iter = -1

        # Krillin starting point
        self.drone_counter = 12
        self.extractor_started = False
        self.spawning_pool_started = False
        self.moved_workers_to_gas = False
        self.moved_workers_from_gas = False
        self.queeen_started = False
        self.mboost_started = False
        #self.write_data = WriteData()

        # Krillin

    async def on_step(self, iteration):
        """Runs on every Gamestep"""
		# self.last_iter = iteration

        if iteration == 0:
            await self.gamemanager.startGame()
            await self.chat_send(f"Name: {self.NAME}")
            await self.chat_send("(glhf)")
            print(f"Name: {self.NAME}")
            #self.write_data.print_start(self.NAME)

        self.iteration = iteration

        # Manage own and enemy Race
        await self.gamemanager.manageRaces()
        # debug code
        self.elapsed_time = iteration * self.gamemanager.bot._client.game_step / 22.4


        if not self.units(HATCHERY).ready.exists:
            for unit in self.workers | self.units(ZERGLING) | self.units(QUEEN):
                await self.do(unit.attack(self.enemy_start_locations[0]))
            return

        hatchery = self.units(HATCHERY).ready.first
        larvae = self.units(LARVA)

        target = self.known_enemy_structures.random_or(self.enemy_start_locations[0]).position
        for zl in self.units(ZERGLING).idle:
            await self.do(zl.attack(target))

        for queen in self.units(QUEEN).idle:
            abilities = await self.get_available_abilities(queen)
            if AbilityId.EFFECT_INJECTLARVA in abilities:
                await self.do(queen(EFFECT_INJECTLARVA, hatchery))

        if self.vespene >= 100:
            sp = self.units(SPAWNINGPOOL).ready
            if sp.exists and self.minerals >= 100 and not self.mboost_started:
                await self.do(sp.first(RESEARCH_ZERGLINGMETABOLICBOOST))
                self.mboost_started = True

            if not self.moved_workers_from_gas:
                self.moved_workers_from_gas = True
                for drone in self.workers:
                    m = self.state.mineral_field.closer_than(10, drone.position)
                    await self.do(drone.gather(m.random, queue=True))

        if self.supply_left < 2:
            if self.can_afford(OVERLORD) and larvae.exists and  self.spawning_pool_started:
                await self.do(larvae.random.train(OVERLORD))

        if self.units(SPAWNINGPOOL).ready.exists:
            if larvae.exists and self.can_afford(ZERGLING):
                await self.do(larvae.random.train(ZERGLING))

        if self.units(EXTRACTOR).ready.exists and not self.moved_workers_to_gas:
            self.moved_workers_to_gas = True
            extractor = self.units(EXTRACTOR).first
            for drone in self.workers.random_group_of(3):
                await self.do(drone.gather(extractor))

        if self.minerals > 500 and self.workers.exists:        
            for d in range(4, 15):
                pos = hatchery.position.to2.towards(self.game_info.map_center, d)
                if await self.can_place(HATCHERY, pos):
                    #self.spawning_pool_started = True
                    await self.do(self.workers.random.build(HATCHERY, pos))
                    break

        if self.drone_counter < 15:
            if self.can_afford(DRONE):
                self.drone_counter += 1
                await self.do(larvae.random.train(DRONE))

        if not self.spawning_pool_started:
            if self.can_afford(SPAWNINGPOOL):
                for d in range(4, 15):
                    pos = hatchery.position.to2.towards(self.game_info.map_center, d)
                    if await self.can_place(SPAWNINGPOOL, pos):
                        drone = self.workers.closest_to(pos)
                        err = await self.do(drone.build(SPAWNINGPOOL, pos))
                        if not err:
                            self.spawning_pool_started = True
                            self.drone_counter -= 1
                            break

        elif not self.extractor_started:
            if self.can_afford(EXTRACTOR):
                drone = self.workers.random
                target = self.state.vespene_geyser.closest_to(drone.position)
                err = await self.do(drone.build(EXTRACTOR, target))
                if not err:
                    self.extractor_started = True
                    self.drone_counter -= 1

        elif not self.queeen_started and self.units(SPAWNINGPOOL).ready.exists:
            if self.can_afford(QUEEN):
                r = await self.do(hatchery.train(QUEEN))
                if not r:
                    self.queeen_started = True

        # # TAGGING
        # for unit in self.units.not_structure.ready:
        #     if unit.tag not in self.unitInfo:
        #         self.unitInfo[unit.tag] = {'worker': 0, 'scout': 0, 'type': 'unit'}
        #
        # # Manage Resources and Workers
        # #await self.resources.manageSupply()
        # await self.resources.manageWorkers()
        #
        # # Kamikaze
        # hq = self.townhalls
        # if not hq:
        #     target = self.known_enemy_structures.random_or(self.enemy_start_locations[0]).position
        #     for unit in self.workers | self.units.not_structure:
        #         self.microActions.append(unit.attack(target))
        #         return
        #
        # # Race Specific Actions
        # if self.race_self == 'Protoss':
        #     await self.protossmanager.Run()
        # elif self.race_self == 'Terran':
        #     await self.terranmanager.Run()
        #
        # War

        # TLL 2019-07-12
        #self.warmanager.write_data = self.write_data
        self.warmanager.iteration = self.iteration
        # TLL 2019-07-12

        await self.warmanager.Run()
        #
        # # Perform microActions
        # await self.do_actions(self.microActions)
        # self.microActions.clear()
