import sc2, sys
from ladder import run_ladder_game
from sc2 import Race, Difficulty
from sc2.player import Bot, Computer
import random

from krillin import Krillin
bot = Bot(Race.Zerg, Krillin())

allmaps = ['AutomatonLE', 'CyberForestLE', 'KairosJunctionLE', 'KingsCoveLE',
'NewRepugnancyLE', 'PortAleksanderLE', 'YearZeroLE'] # all maps

Difficulties = [ Difficulty.Medium, Difficulty.MediumHard,
    Difficulty.Hard, Difficulty.Harder, Difficulty.VeryHard,
    Difficulty.CheatVision, Difficulty.CheatMoney, Difficulty.CheatInsane]
_difficulty = Difficulty.VeryHard

_opponent = random.choice([Race.Zerg, Race.Terran, Race.Protoss, Race.Random])
_save_replay_as="/opt/programming/overmind/local/replays/Krillin-vRCHR-11.SC2Replay"

# Start game
if __name__ == '__main__':
    if "--LadderServer" in sys.argv:
        # Ladder game started by LadderManager
        print("Starting ladder game...")
        run_ladder_game(bot)
    else:
        # Local game
        print("Starting local game...")
        sc2.run_game(sc2.maps.get(random.choice(allmaps)), [
            bot,
            Computer(_opponent, _difficulty)
        ], realtime=False, step_time_limit=2.0, game_time_limit=(60*20),
    save_replay_as=_save_replay_as)
